﻿using EJGrid.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.Linq;
using MvcApp.Models;
using Syncfusion.JavaScript.Models;
using Syncfusion.EJ.Export;
using System.Web.Script.Serialization;
using System.Reflection;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Grid;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Parsing;


namespace MvcApp.Controllers
{
    public class HomeController : Controller
    {

        public ActionResult Index()
        {
            var data = new NorthwindDataContext().OrdersViews.ToList();
            ViewBag.datsource = data;
            return View();
        }

        public void ExportToPdf(string GridModel, string args)
        {
            PdfExport exp = new PdfExport();
            var DataSource = new NorthwindDataContext().OrdersViews.Take(100).ToList(); //Get the Datasource

            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(GridModel, typeof(IEnumerable));

            Dictionary<string, dynamic> gridParams = serializer.Deserialize<Dictionary<string, dynamic>>(GridModel);

            GridProperties gridProp = new GridProperties();

            DrawGrid(DataSource, gridParams);
        }

        private void DrawGrid(List<OrdersView> data,Dictionary<string, dynamic> gridParameters)
        {
            PdfDocument pdfDocument = new PdfDocument();

            PdfPage pdfPage = pdfDocument.Pages.Add();

            PdfGrid pdfGrid = new PdfGrid();
            PdfGrid grid = new PdfGrid();
            int columnCount = ((gridParameters["columns"].Count) - (gridParameters["columns"].Count / 2));
            pdfGrid.Columns.Add(columnCount/2 );

            if (data.Count > 0)
            {
                for (int row = 0; row < data.Count; row++)
                {
                    PdfGridRow PdfRow = pdfGrid.Rows.Add();
                    int column = 0;
                    PdfRow.Cells[column].Value = data[row].OrderID.ToString();
                    PdfRow.Cells[column + 1].Value = data[row].ShipName.ToString();
                    
                    column = 0;
                    PdfRow = pdfGrid.Rows.Add();
                    PdfRow.Cells[column].Value = data[row].CustomerID.ToString();
                    PdfRow.Cells[column + 1].Value = data[row].ShipCountry.ToString();
                    
                    column = 0;
                    PdfRow = pdfGrid.Rows.Add();
                    PdfRow.Cells[column].Value = data[row].EmployeeID.ToString();
                    PdfRow.Cells[column + 1].Value = data[row].ShipCity.ToString();
                    
                    column = 0;
                    PdfRow = pdfGrid.Rows.Add();
                    PdfRow.Cells[column].Value = data[row].Freight.ToString();
                    float height = PdfRow.Height;

                    //empty row
                    column = 0;
                    PdfRow = pdfGrid.Rows.Add();
                    PdfRow.Height = height * 2;
                }
            }

            PdfLayoutResult result = pdfGrid.Draw(pdfPage, 0, 0);
            pdfDocument.Save(Server.MapPath("/Output/output.pdf"));
            pdfDocument.Close(true);
        }
    }
}
